//
// Created by hoelshare on 21.05.17.
//
#include "Player.hpp"
#include "ShotPacket.hpp"

#define min(a, b) ((a)<(b)?(a):(b))
#define max(a, b) ((a)>(b)?(a):(b))

// TODO set constants



void Player::heal(unsigned short healthPoints) {
    unsigned short calcHP = this->currentHP + healthPoints;
    this->currentHP = min(this->maxHP, calcHP);
    updateHealthMenuItem();
}

void Player::hit(unsigned short hitPoints) {
    float armorPercent = (this->currentArmor / (double)this->maxArmor) * this->maxArmorPercent;
    unsigned short playerHitPoints = (1 - armorPercent) * hitPoints;
    unsigned short armorHitPoints = armorPercent * hitPoints;
    short calcHP = this->currentHP - playerHitPoints;
    short calcArmor = this->currentArmor - armorHitPoints;
    this->currentHP = max(short(0), calcHP);
    this->currentArmor = max(short(0), calcArmor);
    updateHealthMenuItem();
    if (!this->currentHP) {
        this->die();
    }
}

void Player::updateHealthMenuItem() {
    if (this->healthMenuItem) {
        char buff[5];
        snprintf(buff, sizeof(buff), "%d %", this->currentHP / this->maxHP * 100);
        String percentage = buff;
        delete[] buff;
        this->healthMenuItem->setText(percentage);
    }
}

void Player::updateArmorMenuItem() {
    if (this->armorMenuItem) {
        char buff[5];
        snprintf(buff, sizeof(buff), "%d %", this->currentArmor / this->maxArmor * 100);
        String percentage = buff;
        delete[] buff;
        this->armorMenuItem->setText(percentage);
//        this->armorMenuItem->setImagePath(String("/ammo" + String(this->weaponIndex) + ".bmp"));
    }
}

void Player::updateAmmoMenuItem() {
    if (this->ammoMenuItem) {
        char buff[20];
        snprintf(buff, sizeof(buff), "%d / %d",
                 this->currentShot[this->weaponIndex], this->shotMagazine[this->weaponIndex]);
        String shotStr = buff;
        delete[] buff;
        this->healthMenuItem->setText(shotStr);
    }
}

void Player::reload() {
    Serial.println("Reload!");
    // Magazine not empty
    // and current not full
    if (this->shotMagazine[this->weaponIndex] &&
        this->currentShot[this->weaponIndex] < Player::magazineSize[this->weaponIndex]) {
        // Wait some time
        delay(Player::magazineReloadTime[this->weaponIndex]);

        // refill
        this->currentShot[weaponIndex] =
                min(Player::magazineSize[this->weaponIndex], this->shotMagazine[this->weaponIndex]) -
                this->currentShot[this->weaponIndex];
    }
    Serial.println("Reload ende");
}

void Player::shot() {
    Serial.println("Shot!");
    if(this->currentShot[this->weaponIndex]) {
        this->currentShot[this->weaponIndex]--;
        sendShotIR();
        delay(Player::shotTime[this->weaponIndex]);
        Serial.println("Nach delay");
    } else {
        reload();
    }
}

void Player::sendShotIR() {
    ShotPacket packet;
    packet.pid = this->pID;
    packet.damage = damage[this->weaponIndex];
    packet.nickname = String(this->nickname);
    String shareString = packet.serial();
    Serial.println(shareString);
    badge->setGPIO(IR_EN, HIGH);
    Serial.println("NEC");
    uint32_t code = 0;
    uint8_t checksum = 0;
    for (int i = 0; i < shareString.length(); i++) {
        checksum += shareString.charAt(i);
        code = code | shareString.charAt(i) << (i % 4) * 8;
        if (i % 4 == 3) {
            irsend.sendNEC(code, 32);
            Serial.println(code, HEX);
            code = 0;
        }
    }
    if (code != 0) {
        irsend.sendNEC(code, 32);
        Serial.println(code, HEX);
    }
    Serial.print("Checksum: ");
    Serial.println(checksum); //224
    code = 0;
    code = checksum << 8 | 222;
    irsend.sendNEC(code, 32);
    badge->setGPIO(IR_EN, LOW);
    Serial.println("Senden fertig");
}

void Player::die() {
    Serial.println("Die!");
    for (unsigned char i = 0; i < 10; i++) {
        pixels.setPixelColor(1, pixels.Color(255, 0, 0));
        pixels.setPixelColor(2, pixels.Color(255, 0, 0));
        pixels.setPixelColor(3, pixels.Color(255, 0, 0));
        pixels.setPixelColor(0, pixels.Color(255, 0, 0));
        badge->setVibrator(true);
        delay(200);
        badge->setVibrator(false);
        pixels.setPixelColor(1, pixels.Color(0, 0, 0));
        pixels.setPixelColor(2, pixels.Color(0, 0, 0));
        pixels.setPixelColor(3, pixels.Color(0, 0, 0));
        pixels.setPixelColor(0, pixels.Color(0, 0, 0));
        pixels.show();
        delay(200);
    }
    rebirth();
}

void Player::rebirth() {
    Serial.println("Rebirth");
    this->currentHP = this->maxHP;
    this->currentArmor = 0;
    for(short i = 0; i < 3; i++) {
        this->currentShot[i] = this->magazineSize[i];
        // TODO refill magazine
    }
}